import tw from './macro'

// Pseudo element variants
tw`first-letter:block`
tw`first-line:block`
tw`marker:block`
tw`selection:block`
tw`file:block`
tw`placeholder:block`
tw`backdrop:block`
tw`before:block`
tw`after:block`
tw`before:(content block)`
tw`after:(content block)`

// Positional
tw`first:block`
tw`last:block`
tw`only:block`
tw`odd:block`
tw`even:block`
tw`first-of-type:block`
tw`last-of-type:block`
tw`only-of-type:block`

// State
tw`visited:block`
tw`target:block`
tw`open:block`

// Forms
tw`default:block`
tw`checked:block`
tw`indeterminate:block`
tw`placeholder-shown:block`
tw`autofill:block`
tw`optional:block`
tw`required:block`
tw`valid:block`
tw`invalid:block`
tw`in-range:block`
tw`out-of-range:block`
tw`read-only:block`

// Content
tw`empty:block`

// Interactive
tw`focus-within:block`
tw`hover:block`
tw`focus:block`
tw`focus-visible:block`
tw`active:block`
tw`enabled:block`
tw`disabled:block`

// Twin custom
tw`all:block`
tw`all-child:block`
tw`sibling:block`
tw`hocus:block`
tw`link:block`
tw`read-write:block`
tw`svg:block`
tw`even-of-type:block`
tw`odd-of-type:block`

// Not versions of the above

// Positional
tw`not-first:block`
tw`not-last:block`
tw`not-only:block`
tw`not-odd:block`
tw`not-even:block`
tw`not-first-of-type:block`
tw`not-last-of-type:block`
tw`not-only-of-type:block`

// State
tw`not-visited:block`
tw`not-target:block`
tw`not-open:block`

// Forms
tw`not-default:block`
tw`not-checked:block`
tw`not-indeterminate:block`
tw`not-placeholder-shown:block`
tw`not-autofill:block`
tw`not-optional:block`
tw`not-required:block`
tw`not-valid:block`
tw`not-invalid:block`
tw`not-in-range:block`
tw`not-out-of-range:block`
tw`not-read-only:block`

// Content
tw`not-empty:block`

// Interactive
tw`not-focus-within:block`
tw`not-hover:block`
tw`not-focus:block`
tw`not-focus-visible:block`
tw`not-active:block`
tw`not-enabled:block`
tw`not-disabled:block`

// Twin custom
tw`not-all:block`
tw`not-all-child:block`
tw`not-sibling:block`
tw`not-hocus:block`
tw`not-link:block`
tw`not-read-write:block`
tw`not-svg:block`
tw`not-even-of-type:block`
tw`not-odd-of-type:block`

tw`ltr:block`
tw`rtl:block`

tw`motion-safe:block`
tw`motion-reduce:block`

tw`dark:block`
tw`light:block`
tw`dark:sm:block`
tw`light:sm:block`
tw`dark:group-hover:sm:block`
tw`light:group-hocus:sm:block`

tw`print:block`
tw`screen:block`

tw`portrait:block`
tw`landscape:block`
tw`contrast-more:block`
tw`contrast-less:block`

tw`any-pointer-none:block`
tw`any-pointer-fine:block`
tw`any-pointer-coarse:block`

tw`pointer-none:block`
tw`pointer-fine:block`
tw`pointer-coarse:block`

tw`any-hover-none:block`
tw`any-hover:block`

tw`can-hover:block`
tw`cant-hover:block`

// Arbitrary values
tw`first:inset-[50px]`
tw`md:text-[red]`

// Random
tw`xl:placeholder-red-500! first:md:block sm:disabled:flex`
